package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.entity.TowerEquipment;
import com.gxwebsoft.tower.param.TowerEquipmentParam;
import com.gxwebsoft.tower.service.TowerEquipmentService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 塔吊设备管理控制器
 *
 * @author 科技小王子
 * @since 2023-05-20 15:06:43
 */
@Api(tags = "塔吊设备管理管理")
@RestController
@RequestMapping("/api/tower/tower-equipment")
public class TowerEquipmentController extends BaseController {
    @Resource
    private TowerEquipmentService towerEquipmentService;

    @PreAuthorize("hasAuthority('tower:towerEquipment:list')")
    @OperationLog
    @ApiOperation("分页查询塔吊设备管理")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerEquipment>> page(TowerEquipmentParam param) {
        // 使用关联查询
        return success(towerEquipmentService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:list')")
    @OperationLog
    @ApiOperation("查询全部塔吊设备管理")
    @GetMapping()
    public ApiResult<List<TowerEquipment>> list(TowerEquipmentParam param) {
        // 使用关联查询
        return success(towerEquipmentService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:list')")
    @OperationLog
    @ApiOperation("根据id查询塔吊设备管理")
    @GetMapping("/{id}")
    public ApiResult<TowerEquipment> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(towerEquipmentService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:save')")
    @OperationLog
    @ApiOperation("添加塔吊设备管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerEquipment towerEquipment) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerEquipment.setUserId(loginUser.getUserId());
        }
        if (towerEquipmentService.save(towerEquipment)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:update')")
    @OperationLog
    @ApiOperation("修改塔吊设备管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerEquipment towerEquipment) {
        if (towerEquipmentService.updateById(towerEquipment)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:remove')")
    @OperationLog
    @ApiOperation("删除塔吊设备管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerEquipmentService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:save')")
    @OperationLog
    @ApiOperation("批量添加塔吊设备管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerEquipment> list) {
        if (towerEquipmentService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:update')")
    @OperationLog
    @ApiOperation("批量修改塔吊设备管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerEquipment> batchParam) {
        if (batchParam.update(towerEquipmentService, "equipment_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:remove')")
    @OperationLog
    @ApiOperation("批量删除塔吊设备管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerEquipmentService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerEquipment:update')")
    @OperationLog
    @ApiOperation("批量修改塔吊设备状态")
    @PutMapping("/status")
    public ApiResult<?> statusBatch(@RequestBody List<TowerEquipment> batchParam) {
      if (towerEquipmentService.updateBatchById(batchParam)) {
        return success("修改成功");
      }
      return fail("修改失败");
    }
}
